<!DOCTYPE html>
<html lang="en"><head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8">
		<title>three.js webgl - lines - cubes</title>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, user-scalable=no, minimum-scale=1.0, maximum-scale=1.0">
		<style>
			body {
				background-color: #000000;
				margin: 0px;
				overflow: hidden;
			}

			a {
				color:#0078ff;
			}

			#info {
				position: absolute;
				top: 10px; width: 100%;
				color: #ffffff;
				padding: 5px;
				font-family: Monospace;
				font-size: 13px;
				text-align: center;
				z-index:100;
			}

			a {
				color: orange;
				text-decoration: none;
			}

			a:hover {
				color: #0080ff;
			}

		</style>
	</head>
	<body>
		<div id="info">
			[<a href="http://en.wikipedia.org/wiki/Hilbert_curve">Hilbert curve</a> mapping of Ethereum private keys to public keys and public addresses.]
		</div>
		<script src="three.js"></script>
		<script src="hilbert3D.js"></script>
		<script src="Detector.js"></script>
		<script src="stats.js"></script>

<script>
			console.log("updated!");
			// The goal of this file is to display a keyscape consisting of 3 rotating cubes
			// and a large number of connections between them
			// the stretch goal is to display the numbers the connections are based on

			// Release goal: working number display, working 'win' response

			if ( ! Detector.webgl ) Detector.addGetWebGLMessage();

			var mouseX = 0, mouseY = 0,
			windowHalfX = window.innerWidth / 2,
			windowHalfY = window.innerHeight / 2,
			camera, scene, renderer;



			var hilbertIterations = 3;

			//keysToMappings accepts keys, outputs vertex array indices
			var keysToMappings = function keysToMappings ( hilbertIterations, privkey, pubkey, pubaddress ) {
				return {privkeyMap: 5, pubkeyMap: 7, pubaddressMap: 3};
			}
			var newConTripleHELPER = [];
			// creates a new line connecting 1 vertex on each of 3 cubes and adds it to the scene
			var newConnectionTriple = function newConnectionTriple ( privkeyCube, privkeyMap, pubkeyCube, pubkeyMap, pubaddressCube, pubaddressMap ) {
				var privkeyVertex = privkeyCube.geometry.vertices[privkeyMap].clone()
				var pubkeyVertex = pubkeyCube.geometry.vertices[pubkeyMap].clone()
				var pubaddressVertex = pubaddressCube.geometry.vertices[pubaddressMap].clone()

				var connectionTripleGeo = new THREE.Geometry();
				connectionTripleGeo.vertices.push(privkeyVertex);
				connectionTripleGeo.vertices.push(pubkeyVertex);
				connectionTripleGeo.vertices.push(pubaddressVertex);
				var connectionTriple = new THREE.LineLoop(connectionTripleGeo);
				connectionTriple.scale.x = connectionTriple.scale.y = connectionTriple.scale.z =  1;
				connectionTriple.position.x = connectionTriple.position.y = connectionTriple.position.z = 0;

				connectionTriple.selfUpdateVertices = function selfUpdateVertices () {
					connectionTriple.geometry.vertices[0] = privkeyVertex.clone().applyMatrix4(privkeyCube.matrixWorld);
					connectionTriple.geometry.vertices[1] = pubkeyVertex.clone().applyMatrix4(pubkeyCube.matrixWorld);
					connectionTriple.geometry.vertices[2] = pubaddressVertex.clone().applyMatrix4(pubaddressCube.matrixWorld);
				}
				connectionTriple.selfUpdateVertices();
				scene.add(connectionTriple);
			}

			init();
			animate();

			function makeNewMockConnection() {
				newConnectionTriple(newConTripleHELPER[0],(~~(Math.random()*4096)),newConTripleHELPER[1],(~~(Math.random()*4096)),newConTripleHELPER[2],(~~(Math.random()*4096)))
			}


			function init() {

				var i, container;

				container = document.createElement( 'div' );
				document.body.appendChild( container );

				camera = new THREE.PerspectiveCamera( 33, window.innerWidth / window.innerHeight, 1, 10000 );
				camera.position.z = 700;

				scene = new THREE.Scene();

				renderer = new THREE.WebGLRenderer();
				renderer.setPixelRatio( window.devicePixelRatio );
				renderer.setSize( window.innerWidth, window.innerHeight );
				container.appendChild( renderer.domElement );


				var geometry = new THREE.Geometry(),
					points = hilbert3D( new THREE.Vector3( 0,0,0 ), 200.0, hilbertIterations, 0, 1, 2, 3, 4, 5, 6, 7 );

				for ( i = 0; i < points.length; i ++ ) {
					geometry.vertices.push( points[i] );
				}

				// lines
				var line, p, scale = 0.5, d = 125, c1 = 0x553300, c2 = 0x555555, c3 = 0x992800, g1 = geometry,
					m1 = new THREE.LineBasicMaterial( { color: c1, opacity: 1, blending: THREE.AdditiveBlending, transparent: true } ),
					m2 = new THREE.LineBasicMaterial( { color: c2, opacity: 0.5, blending: THREE.AdditiveBlending, transparent: true } ),
					m3 = new THREE.LineBasicMaterial( { color: c3, opacity: 1, blending: THREE.AdditiveBlending, transparent: true } ),

					parameters =
										[
											[ m1, scale, [-d, 0, 0],  g1 ],
											[ m2, scale, [d, 0, 0],  g1 ],
											[ m3, scale*.5, [d,0,0],  g1 ]
								   ];

				for ( i = 0; i < parameters.length; i ++ ) {

					p = parameters[ i ];

					line = new THREE.Line( p[ 3 ],  p[ 0 ] );

					line.scale.x = line.scale.y = line.scale.z =  p[ 1 ];

					line.position.x = p[ 2 ][ 0 ];
					line.position.y = p[ 2 ][ 1 ];
					line.position.z = p[ 2 ][ 2 ];

					scene.add( line );
					newConTripleHELPER.push( line );
				}

				document.addEventListener( 'mousemove', onDocumentMouseMove, false );
				document.addEventListener( 'touchstart', onDocumentTouchStart, false );
				document.addEventListener( 'touchmove', onDocumentTouchMove, false );

				window.addEventListener( 'resize', onWindowResize, false );

			}

			function onWindowResize() {

				windowHalfX = window.innerWidth / 2;
				windowHalfY = window.innerHeight / 2;

				camera.aspect = window.innerWidth / window.innerHeight;
				camera.updateProjectionMatrix();

				renderer.setSize( window.innerWidth, window.innerHeight );

			}

			//

			function onDocumentMouseMove(event) {

				mouseX = event.clientX - windowHalfX;
				mouseY = event.clientY - windowHalfY;
			}

			function onDocumentTouchStart( event ) {

				if ( event.touches.length > 1 ) {

					event.preventDefault();

					mouseX = event.touches[ 0 ].pageX - windowHalfX;
					mouseY = event.touches[ 0 ].pageY - windowHalfY;

				}

			}

			function onDocumentTouchMove( event ) {

				if ( event.touches.length == 1 ) {

					event.preventDefault();

					mouseX = event.touches[ 0 ].pageX - windowHalfX;
					mouseY = event.touches[ 0 ].pageY - windowHalfY;

				}

			}

			//

			function animate() {
				requestAnimationFrame( animate );
				render();
			}

			function render() {

				camera.position.x += ( mouseX - camera.position.x ) * .05;
				camera.position.y += ( - mouseY + 200 - camera.position.y ) * .05;

				camera.lookAt( scene.position );

				var time = Date.now() * 0.0015;

				//generating mock connections
				if((Math.random()*100) >= 95 ){
					makeNewMockConnection();
					console.log(scene.children.length)
					if (Math.random()*99 >= (105 - scene.children.length) && (scene.children[10].selfUpdateVertices) ) {
						scene.remove(scene.children[10]);
						console.log("trimming")
					}
				}

				//culling
				if ( scene.children.length > 100) {
					console.log("culling")
					for ( var i = 0; i < scene.children.length; i ++ ) {
						var object = scene.children[ i ];
						if (object.selfUpdateVertices) {
							if (Math.random() > 0.001 ) {
								scene.remove(scene.children[i]);
							}
						}
					}
				}

				for ( var i = 0; i < scene.children.length; i ++ ) {

					var object = scene.children[ i ];

					//  spin
					if ( object === newConTripleHELPER[0] || object === newConTripleHELPER[2]) {object.rotation.y = time/2;}// * ( i % 2 ? 1 : -1 );
					if ( object === newConTripleHELPER[1] ) {object.rotation.y = -time/3;object.rotation.z = -time/2;object.rotation.x = -time/7;}

					//update the connections
					if (object.selfUpdateVertices) {object.selfUpdateVertices()};

					//THIS IS THE SUPER KEY !!!
					if (object.geometry) {object.geometry.verticesNeedUpdate = true;}
					//THIS RIGHT HERE!!^^!!^^!!!!!
				}

				renderer.render( scene, camera );

			}

		</script><div><canvas width="738" height="639" style="width: 738px; height: 639px;"></canvas></div>


</body></html>
